'use strict';

var postcss = require('postcss');
var loaderUtils = require('loader-utils');
var processCss = require('css-loader/lib/processCss');

function toIndex(str, _ref) {
  var line = _ref.line,
      column = _ref.column;

  var regex = /\n/gm,
      index = 0;
  for (var i = 0; i < line - 1; i++) {
    index = regex.exec(str).index;
  }
  return index + column;
}

function extract(css, start, end) {
  return css.substring(toIndex(css, start) - 1, toIndex(css, end) + 1).trim();
}

module.exports = function (content) {
  var query = loaderUtils.getOptions(this) || {};
  var moduleMode = query.modules || query.module;
  var callback = this.async();

  processCss(content, null, {
    mode: moduleMode ? 'local' : 'global',
    from: loaderUtils.getRemainingRequest(this).split('!').pop(),
    to: loaderUtils.getCurrentRequest(this).split('!').pop(),
    minimize: this.minimize,
    loaderContext: this,
    sourceMap: false,
    query: query
  }, function (err, _ref2) {
    var source = _ref2.source,
        exports = _ref2.exports;

    var ast = postcss.parse(source);
    var newSrc = 'const css = require(\'emotion\').css;';
    //   ${rules
    //       .map(rule => {
    //         return `css\`\n${rule}\`;`
    //       })
    //       .join('\n\n')}
    // `
    //
    //     Object.keys(exports).map((name) => {
    //       const cls = exports[name]
    //
    //     })
    this.callback(err, newSrc);
  }.bind(this));
  var ast = postcss.parse(content);

  var rules = ast.nodes.map(function (n) {
    // console.log(JSON.stringify(n, null, 2))
    return extract(content, n.source.start, n.source.end);
  });
  var newSrc = 'const css = require(\'emotion\').css;\n    ' + rules.map(function (rule) {
    return 'css`\n' + rule + '`;';
  }).join('\n\n') + '\n  ';
  // return newSrc
};